org.eclipse.jgit.transport

## Class BundleWriter

- java.lang.Object
- - org.eclipse.jgit.transport.BundleWriter

    public class BundleWriter
    extends Object

Creates a Git bundle file, for sneaker-net transport to another system.

Bundles generated by this class can be later read in from a file URI using the bundle transport, or from an application controlled buffer by the more generic `TransportBundleStream`.

Applications creating bundles need to call one or more `include` calls to reflect which objects should be available as refs in the bundle for the other side to fetch. At least one include is required to create a valid bundle file, and duplicate names are not permitted.

Optional `assume` calls can be made to declare commits which the recipient must have in order to fetch from the bundle file. Objects reachable from these assumed commits can be used as delta bases in order to reduce the overall bundle size.

### Constructor Summary

Constructors
Constructor and Description
`BundleWriter(Repository repo)` Create a writer for a bundle.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `assume(RevCommit c)` Assume a commit is available on the recipient's side.
`void` `include(Ref r)` Include a single ref (a name/object pair) in the bundle.
`void` `include(String name, AnyObjectId id)` Include an object (and everything reachable from it) in the bundle.
`void` `setPackConfig(PackConfig pc)` Set the configuration used by the pack generator.
`void` `writeBundle(ProgressMonitor monitor, OutputStream os)` Generate and write the bundle to the output stream.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### BundleWriter

    public BundleWriter(Repository repo)

Create a writer for a bundle.

Parameters:
  `repo` - repository where objects are stored.

### Method Detail

#### setPackConfig

    public void setPackConfig(PackConfig pc)

Set the configuration used by the pack generator.

Parameters:
  `pc` - configuration controlling packing parameters. If null the source repository's settings will be used.

#### include

    public void include(String name,
                        AnyObjectId id)

Include an object (and everything reachable from it) in the bundle.

Parameters:
  `name` - name the recipient can discover this object as from the bundle's list of advertised refs . The name must be a valid ref format and must not have already been included in this bundle writer.
  `id` - object to pack. Multiple refs may point to the same object.

#### include

    public void include(Ref r)

Include a single ref (a name/object pair) in the bundle.

This is a utility function for: `include(r.getName(), r.getObjectId())`.

Parameters:
  `r` - the ref to include.

#### assume

    public void assume(RevCommit c)

Assume a commit is available on the recipient's side.

In order to fetch from a bundle the recipient must have any assumed commit. Each assumed commit is explicitly recorded in the bundle header to permit the recipient to validate it has these objects.

Parameters:
  `c` - the commit to assume being available. This commit should be parsed and not disposed in order to maximize the amount of debugging information available in the bundle stream.

#### writeBundle

    public void writeBundle(ProgressMonitor monitor,
                            OutputStream os)
                     throws IOException

Generate and write the bundle to the output stream.

This method can only be called once per BundleWriter instance.

Parameters:
  `monitor` - progress monitor to report bundle writing status to.
  `os` - the stream the bundle is written to. The stream should be buffered by the caller. The caller is responsible for closing the stream.
Throws:
  `IOException` - an error occurred reading a local object's data to include in the bundle, or writing compressed object data to the output stream.